"use strict";

var _interopRequireWildcard = require("@babel/runtime-corejs2/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime-corejs2/helpers/interopRequireDefault");

var _Object$defineProperty = require("@babel/runtime-corejs2/core-js/object/define-property");

_Object$defineProperty(exports, "__esModule", {
  value: true
});

exports.default = injectScrollable;

var _getOwnPropertyDescriptor = _interopRequireDefault(require("@babel/runtime-corejs2/core-js/object/get-own-property-descriptor"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime-corejs2/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime-corejs2/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime-corejs2/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime-corejs2/helpers/getPrototypeOf"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime-corejs2/helpers/inherits"));

var _applyDecoratedDescriptor2 = _interopRequireDefault(require("@babel/runtime-corejs2/helpers/applyDecoratedDescriptor"));

var _react = _interopRequireWildcard(require("react"));

var _reactTransformHmr3 = _interopRequireDefault(require("react-transform-hmr"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _coreDecorators = require("core-decorators");

var _reactComponentUtils = require("@ciscospark/react-component-utils");

var _components = {
  ScrollableComponent: {
    displayName: "ScrollableComponent",
    isInFunction: true
  }
};

var _reactTransformHmr2 = (0, _reactTransformHmr3.default)({
  filename: "packages/node_modules/@ciscospark/react-hoc-scrollable/src/index.js",
  components: _components,
  locals: [module],
  imports: [_react.default]
});

function _wrapComponent(id) {
  return function (Component) {
    return _reactTransformHmr2(Component, id);
  };
}

var styles = {
  "scrollable": "scrollable--3vkyW"
}; // @related-file ./styles.css

var propTypes = {
  onScroll: _propTypes.default.func
};
var defaultProps = {
  onScroll: function onScroll() {}
};

function injectScrollable(WrappedComponent) {
  var _class;

  var ScrollableComponent = (_class =
  /*#__PURE__*/
  function (_Component) {
    (0, _inherits2.default)(ScrollableComponent, _Component);

    function ScrollableComponent() {
      (0, _classCallCheck2.default)(this, ScrollableComponent);
      return (0, _possibleConstructorReturn2.default)(this, (0, _getPrototypeOf2.default)(ScrollableComponent).apply(this, arguments));
    }

    (0, _createClass2.default)(ScrollableComponent, [{
      key: "shouldComponentUpdate",
      value: function shouldComponentUpdate(nextProps) {
        return nextProps !== this.props;
      }
    }, {
      key: "getNode",
      value: function getNode(node) {
        this.node = node;
      }
    }, {
      key: "getScrollHeight",
      value: function getScrollHeight() {
        return this.node.scrollHeight;
      }
    }, {
      key: "getScrollTop",
      value: function getScrollTop() {
        return this.node.scrollTop;
      }
    }, {
      key: "setScrollTop",
      value: function setScrollTop(top) {
        this.node.scrollTop = top;
      }
    }, {
      key: "scrollToBottom",
      value: function scrollToBottom() {
        var node = this.node;
        node.scrollTop = node.scrollHeight;
      }
    }, {
      key: "isScrolledToTop",
      value: function isScrolledToTop() {
        return this.node.scrollTop < 100;
      }
    }, {
      key: "isScrolledToBottom",
      value: function isScrolledToBottom() {
        var node = this.node;
        return node.scrollHeight - node.offsetHeight - node.scrollTop < 150;
      }
    }, {
      key: "render",
      value: function render() {
        return _react.default.createElement("div", {
          className: styles.scrollable,
          onScroll: this.props.onScroll,
          ref: this.getNode
        }, _react.default.createElement(WrappedComponent, this.props));
      }
    }]);
    return ScrollableComponent;
  }(_react.Component), ((0, _applyDecoratedDescriptor2.default)(_class.prototype, "getNode", [_coreDecorators.autobind], (0, _getOwnPropertyDescriptor.default)(_class.prototype, "getNode"), _class.prototype)), _class);
  ScrollableComponent = _wrapComponent("ScrollableComponent")(ScrollableComponent);
  ScrollableComponent.propTypes = propTypes;
  ScrollableComponent.defaultProps = defaultProps;
  ScrollableComponent.displayName = "ScrollableComponent(".concat((0, _reactComponentUtils.getDisplayName)(WrappedComponent), ")");
  ScrollableComponent.WrappedComponent = WrappedComponent;
  return ScrollableComponent;
}