import React, { Component } from 'react';
import PropTypes from 'prop-types';
import { autobind } from 'core-decorators';
import { getDisplayName } from '@ciscospark/react-component-utils';

function styleInject(css, ref) {
  if (ref === void 0) ref = {};
  var insertAt = ref.insertAt;

  if (!css || typeof document === 'undefined') {
    return;
  }

  var head = document.head || document.getElementsByTagName('head')[0];
  var style = document.createElement('style');
  style.type = 'text/css';

  if (insertAt === 'top') {
    if (head.firstChild) {
      head.insertBefore(style, head.firstChild);
    } else {
      head.appendChild(style);
    }
  } else {
    head.appendChild(style);
  }

  if (style.styleSheet) {
    style.styleSheet.cssText = css;
  } else {
    style.appendChild(document.createTextNode(css));
  }
}

var css = ".react-hoc-scrollable__scrollable__LnNjcm9s {\n  overflow: hidden;\n  overflow-y: scroll;\n  flex: 1;\n}\n";
var styles = {"scrollable":"react-hoc-scrollable__scrollable__LnNjcm9s"};
styleInject(css);

const propTypes = {
  onScroll: PropTypes.func
};
const defaultProps = {
  onScroll: () => {}
};
function injectScrollable(WrappedComponent) {
  var _class;

  let ScrollableComponent = (_class = class ScrollableComponent extends Component {
    shouldComponentUpdate(nextProps) {
      return nextProps !== this.props;
    }

    getNode(node) {
      this.node = node;
    }

    getScrollHeight() {
      return this.node.scrollHeight;
    }

    getScrollTop() {
      return this.node.scrollTop;
    }

    setScrollTop(top) {
      this.node.scrollTop = top;
    }

    scrollToBottom() {
      const {
        node
      } = this;
      node.scrollTop = node.scrollHeight;
    }

    isScrolledToTop() {
      return this.node.scrollTop < 100;
    }

    isScrolledToBottom() {
      const {
        node
      } = this;
      return node.scrollHeight - node.offsetHeight - node.scrollTop < 150;
    }

    render() {
      return React.createElement("div", {
        className: styles.scrollable,
        onScroll: this.props.onScroll,
        ref: this.getNode
      }, React.createElement(WrappedComponent, this.props));
    }

  }, (babelHelpers.applyDecoratedDescriptor(_class.prototype, "getNode", [autobind], Object.getOwnPropertyDescriptor(_class.prototype, "getNode"), _class.prototype)), _class);
  ScrollableComponent.propTypes = propTypes;
  ScrollableComponent.defaultProps = defaultProps;
  ScrollableComponent.displayName = `ScrollableComponent(${getDisplayName(WrappedComponent)})`;
  ScrollableComponent.WrappedComponent = WrappedComponent;
  return ScrollableComponent;
}

export default injectScrollable;
//# sourceMappingURL=index.js.map
